blob: adb0b051b67703b7c318e9819d3ecff1f78ff600 [file] [log] [blame]
Sean Condonf6af2a52018-08-19 10:43:24 +01001"""
2 Copyright 2018-present Open Networking Foundation
3
4 Licensed under the Apache License, Version 2.0 (the "License");
5 you may not use this file except in compliance with the License.
6 You may obtain a copy of the License at
7
8 http://www.apache.org/licenses/LICENSE-2.0
9
10 Unless required by applicable law or agreed to in writing, software
11 distributed under the License is distributed on an "AS IS" BASIS,
12 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 See the License for the specific language governing permissions and
14 limitations under the License.
15"""
16
17"""
18 Rules to build the ONOS GUI 2
19
Sean Condon0c577f62018-11-18 22:40:05 +000020 The GUI2 Angular 7 elements are built here with Angular CLI 'ng'
Sean Condonf6af2a52018-08-19 10:43:24 +010021 Some work is being done in the Bazel community to integrate Bazel and
Sean Condon0c577f62018-11-18 22:40:05 +000022 Angular 7, (Angular Buildtools Convergence -
Sean Condonf6af2a52018-08-19 10:43:24 +010023 https://docs.google.com/document/d/1OlyiUnoTirUj4gecGxJeZBcjHcFr36RvLsvpBl2mxA8/preview)
24 but it is in the very early stages (Aug'18) and not yet fit
25 for production and at present it works as a replacement for Angular CLI
26 (which is not desirable).
27
28 There are plans to extend Bazel it to work with Angular CLI, and if works
29 well this Bazel file may be rearchiteced in future.
30
31 Bazel and npm are incompatibe in how they deal with files. npm likes to
32 follow links to get back to the original canonical path names, and bazel
33 uses links extensively when populating the sandbox. To get around these
34 problems, the rules that follow use filegroups to specify the files as
35 dependencies and then use a genrule to convert the files into a tar ball.
36 Once the tar ball is unrolled into the sandbox, the links are broken, but
37 the build is still hermetic since those files are referred to as dependencies in the genrule.
38"""
39
40COMPILE_DEPS = CORE_DEPS + JACKSON + KRYO + [
41 "@javax_ws_rs_api//jar",
42 "@servlet_api//jar",
43 "@jetty_websocket//jar",
44 "@jetty_util//jar",
45 "@jersey_media_multipart//jar",
46 "@jersey_server//jar",
Ray Milkey427e9752018-11-15 16:34:48 -080047 "@jersey_hk2//jar",
Sean Condonf6af2a52018-08-19 10:43:24 +010048 "//utils/rest:onlab-rest",
49 "//core/store/serializers:onos-core-serializers",
50]
51
52TEST_DEPS = TEST + [
53 "//core/api:onos-api-tests",
54 "//drivers/default:onos-drivers-default",
55]
56
57"""
58 Files that get put at the top level of the tar ball
59"""
60
61filegroup(
62 name = "_root_level_files",
63 srcs =
64 [
65 ":angular.json",
66 ":karma.conf.js",
67 ":package.json",
68 ":package-lock.json",
69 ":protractor.conf.js",
70 ":src/main/tsconfig.json",
71 ":src/main/tslint.json",
72 ":tsconfig.json",
73 ],
74)
75
76filegroup(
77 name = "_e2e_test_files",
78 srcs = [
79 ":e2e/app.e2e-spec.ts",
80 ":e2e/app.po.ts",
81 ":e2e/tsconfig.e2e.json",
82 ],
83)
84
85"""
86 Files that get put into the WEB-INF directory of the tar ball
87"""
88
89filegroup(
90 name = "_web_inf_classes_files",
91 srcs =
92 [
93 ":src/main/webapp/error.html",
94 ":src/main/webapp/login.html",
95 ":src/main/webapp/nav.html",
96 ":src/main/webapp/not-ready.html",
Sean Condon55c30532018-10-29 12:26:57 +000097 ":src/main/webapp/onos.global.css",
Sean Condonf6af2a52018-08-19 10:43:24 +010098 ],
99)
100
101"""
Sean Condonf6af2a52018-08-19 10:43:24 +0100102 Run ng build to create outputs in production mode
103 See bazel-genfiles/web/gui2/onos-gui2-ng-build-prod.log for details of the Angular CLI output
Sean Condon5ca00262018-09-06 17:55:25 +0100104
105 To avoid the overhead of having several "npm install" invocations, we just do
Sean Condon0c577f62018-11-18 22:40:05 +0000106 it once in the //web/gui2-fw-lib which is really the core for the whole Angular 7
Sean Condon5ca00262018-09-06 17:55:25 +0100107 structure in ONOS. This copies files in to node_modules, but because the gui2-fw-lib
108 has not been generated at that time we copy it in separately below with the 'tar' cmd
109 and then 'mv'
Sean Condonf6af2a52018-08-19 10:43:24 +0100110"""
111
112genrule(
113 name = "_onos-gui2-ng-build",
114 srcs = [
115 "@nodejs//:bin/npm",
116 "@nodejs//:bin/node",
Sean Condonf6af2a52018-08-19 10:43:24 +0100117 "@nodejs//:bin/nodejs/bin/node",
118 "@nodejs//:bin/nodejs/bin/npm",
Sean Condon5ca00262018-09-06 17:55:25 +0100119 "//web/gui2-fw-lib:onos-gui2-fw-npm-install",
120 "//web/gui2-fw-lib:onos-gui2-fw-ng-build",
121 "//web/gui2-fw-lib:gui2_fw_lib_ext_css",
Sean Condon87b78502018-09-17 20:53:24 +0100122 "//apps/faultmanagement/fm-gui2-lib:fm-gui2-lib-build",
Sean Condon5ca00262018-09-06 17:55:25 +0100123 ":_root_level_files",
Sean Condonf6af2a52018-08-19 10:43:24 +0100124 ":_web_app_all",
125 ],
126 outs = [
127 "onos-gui2-ng-build-prod.log",
128 "onos-gui2-ng-build.jar",
129 ],
130 cmd = "ROOT=`pwd` &&" +
131 " export HOME=. &&" +
132 " export XDG_CONFIG_HOME=$(@D)/config &&" +
133 " NODE=$(location @nodejs//:bin/node) &&" +
Sean Condon5ca00262018-09-06 17:55:25 +0100134 " INSTALL_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-npm-install)) &&" + # An array of filenames - sorted by time created
135 " FWLIB_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-ng-build)) &&" + # An array of filenames - sorted by time created
Sean Condonf6af2a52018-08-19 10:43:24 +0100136 " mkdir -p web/gui2 && cd web/gui2 &&" +
137 " jar xf ../../$(location :_web_app_all) &&" +
138 " jar xf $$ROOT/$${INSTALL_FILES[0]} &&" +
Sean Condon5ca00262018-09-06 17:55:25 +0100139 " tar xf $$ROOT/$${FWLIB_FILES[0]} &&" +
140 " mv package/ node_modules/gui2-fw-lib/ &&" +
Sean Condon87b78502018-09-17 20:53:24 +0100141 # Add in modules from external packages
142 " FM_GUI2_LIB_FILES=($(locations //apps/faultmanagement/fm-gui2-lib:fm-gui2-lib-build)) &&" + # An array of filenames - sorted by time created
143 " tar xf $$ROOT/$${FM_GUI2_LIB_FILES[0]} &&" +
144 " mv package/ node_modules/fm-gui2-lib/ &&" +
145 # End of add in modules from external packages
Sean Condon5ca00262018-09-06 17:55:25 +0100146 " mkdir -p src/main/webapp/app/fw &&" +
147 " (cd src/main/webapp/app/fw &&" +
148 " jar xf $$ROOT/$(location //web/gui2-fw-lib:gui2_fw_lib_ext_css)) &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100149 " chmod +x $$ROOT/web/gui2/node_modules/@angular/cli/bin/ng &&" +
Thomas Vachuska0c19e652018-08-28 10:57:07 -0700150 " export PATH=$$ROOT/$$(dirname $${NODE}):$$ROOT/web/gui2/node_modules/@angular/cli/bin:$$PATH &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100151 " node -v > ../../$(location onos-gui2-ng-build-prod.log) &&" +
152 " npm -v >> ../../$(location onos-gui2-ng-build-prod.log) &&" +
Sean Condon0c577f62018-11-18 22:40:05 +0000153 " ng version >> ../../$(location onos-gui2-ng-build-prod.log) &&" +
154 " ng build --extract-css --prod --preserve-symlinks" +
Sean Condon87b78502018-09-17 20:53:24 +0100155 " --base-href /onos/ui2/ --deploy-url /onos/ui2/ >> $$ROOT/$(location onos-gui2-ng-build-prod.log) 2>&1 ||" +
156 " if [ $$? -eq 0 ]; then echo 'Successfully ran build';" +
157 " else " +
158 " echo 'Error running \'ng build\' on \'//web/gui2:_onos-gui2-ng-build\'. \\\n" +
159 " See bazel-genfiles/web/gui2/onos-gui2-ng-build-prod.log for more details' >&2;" +
160 #" tail -n 100 ../../$(location onos-gui2-ng-test.log) >&2;" +
161 " exit 1;" +
162 " fi;" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100163 " cd src/main/webapp/dist && jar Mcf $$ROOT/$(location onos-gui2-ng-build.jar) .",
Sean Condon0c577f62018-11-18 22:40:05 +0000164 message = "Angular CLI 7 build",
Sean Condonf6af2a52018-08-19 10:43:24 +0100165)
166
167"""
168 Run 'ng test' to run Angular test and 'ng lint' for checkstyle
169 See bazel-genfiles/web/gui2/onos-gui2-ng-lint.log or
170 bazel-genfiles/web/gui2/onos-gui2-ng-test.log for details of the Angular CLI output
171"""
172
173genrule(
174 name = "_onos-gui2-ng-test-genrule",
175 srcs = [
176 "@nodejs//:bin/npm",
177 "@nodejs//:bin/node",
Sean Condonf6af2a52018-08-19 10:43:24 +0100178 "@nodejs//:bin/nodejs/bin/node",
179 "@nodejs//:bin/nodejs/bin/npm",
Sean Condon5ca00262018-09-06 17:55:25 +0100180 "//web/gui2-fw-lib:onos-gui2-fw-npm-install",
181 "//web/gui2-fw-lib:onos-gui2-fw-ng-build",
182 "//web/gui2-fw-lib:gui2_fw_lib_ext_css",
Sean Condonf6af2a52018-08-19 10:43:24 +0100183 ":_web_app_all",
184 ":_web_app_tests",
185 ":_angular_all",
186 ],
187 outs = [
188 "onos-gui2-ng-ver.log",
189 "onos-gui2-ng-lint.log",
190 "onos-gui2-ng-test.log",
191 ],
192 cmd = " ROOT=`pwd` &&" +
193 " export HOME=. &&" +
194 " export XDG_CONFIG_HOME=$(@D)/config &&" +
195 " NODE=$(location @nodejs//:bin/node) &&" +
Sean Condon5ca00262018-09-06 17:55:25 +0100196 " INSTALL_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-npm-install)) &&" + # An array of filenames - sorted by time created
197 " FWLIB_FILES=($(locations //web/gui2-fw-lib:onos-gui2-fw-ng-build)) &&" + # An array of filenames - sorted by time created
Sean Condonf6af2a52018-08-19 10:43:24 +0100198 " mkdir -p web/gui2 &&" +
199 " cd web/gui2 &&" +
200 " jar xf ../../$(location :_angular_all) &&" +
201 " jar xf ../../$(location :_web_app_all) &&" +
202 " jar xf ../../$(location :_web_app_tests) &&" +
203 " jar xf $$ROOT/$${INSTALL_FILES[0]} &&" +
Sean Condon5ca00262018-09-06 17:55:25 +0100204 " tar xf $$ROOT/$${FWLIB_FILES[0]} &&" +
205 " mv package/ node_modules/gui2-fw-lib/ &&" +
206 " mkdir -p src/main/webapp/app/fw &&" +
207 " (cd src/main/webapp/app/fw &&" +
208 " jar xf $$ROOT/$(location //web/gui2-fw-lib:gui2_fw_lib_ext_css)) &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100209 " chmod +x $$ROOT/web/gui2/node_modules/@angular/cli/bin/ng &&" +
Thomas Vachuska0c19e652018-08-28 10:57:07 -0700210 " export PATH=$$ROOT/$$(dirname $${NODE}):$$ROOT/web/gui2/node_modules/@angular/cli/bin:$$PATH &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100211 " node -v > ../../$(location onos-gui2-ng-ver.log) &&" +
212 " npm -v >> ../../$(location onos-gui2-ng-ver.log) &&" +
Sean Condon0c577f62018-11-18 22:40:05 +0000213 " ng version >> ../../$(location onos-gui2-ng-ver.log) &&" +
Sean Condonf6af2a52018-08-19 10:43:24 +0100214 " ng lint > ../../$(location onos-gui2-ng-lint.log);" +
215 " if [ -f /usr/bin/chromium-browser ]; then " + # Add to this for Mac and Chrome
216 " export CHROME_BIN=/usr/bin/chromium-browser; " +
217 " elif [ -f /opt/google/chrome/chrome ]; then " +
218 " export CHROME_BIN=/opt/google/chrome/chrome; " +
219 " else " +
220 " MSG='Warning: Step onos-gui2-ng-test skipped because \\n" +
221 " no binary for ChromeHeadless browser was found at /usr/bin/chromium-browser. \\n" +
222 " Install Google Chrome or Chromium Browser to allow this step to run.';" +
223 " echo -e $$MSG >&2;" +
224 " echo -e $$MSG > ../../$(location onos-gui2-ng-test.log);" +
225 " exit 0;" +
226 " fi;" +
227 " ng test --preserve-symlinks --code-coverage --browsers=ChromeHeadless" +
228 " --watch=false > ../../$(location onos-gui2-ng-test.log) 2>&1 ||" +
229 " if [ $$? -eq 0 ]; then echo 'Successfully ran tests';" +
230 " else " +
231 " echo 'Error running \'ng test\' on \'//web/gui2:onos-gui2-ng-test\'. \\\n" +
232 " See bazel-genfiles/web/gui2/onos-gui2-ng-test.log for more details' >&2;" +
233 #" tail -n 100 ../../$(location onos-gui2-ng-test.log) >&2;" +
234 " exit 1;" +
235 " fi;",
Sean Condon0c577f62018-11-18 22:40:05 +0000236 message = "Angular CLI 7 lint and test",
Sean Condonf6af2a52018-08-19 10:43:24 +0100237)
238
239"""
240 Make a jar file of all the webapp files. Useful for breaking symblic links in the sandbox
241"""
242
243genrule(
244 name = "_web_app_all",
245 srcs = glob(
246 [
247 "src/main/webapp/**",
248 ],
249 exclude = [
250 "src/main/webapp/**/*.spec.ts", # Don't track tests here
251 "src/main/webapp/tests/**",
252 "src/main/webapp/node_modules/**",
253 "src/main/webapp/dist/**",
254 "src/main/webapp/doc/**",
Sean Condon87b78502018-09-17 20:53:24 +0100255 "src/main/webapp/app/fw/**",
Sean Condonf6af2a52018-08-19 10:43:24 +0100256 ],
257 ),
258 outs = ["web_app_all.jar"],
259 cmd = "cd web/gui2 &&" +
260 " find src/main/webapp -type f -exec touch -t 201808280000 {} \; &&" +
261 " jar Mcf ../../$@ src/main/webapp",
262)
263
264"""
265 Make a jar file of all the webapp test (*.spec.ts) files.
266"""
267
268genrule(
269 name = "_web_app_tests",
270 srcs = glob(
271 [
272 "src/main/webapp/**/*.spec.ts",
273 ],
274 exclude = [
275 "src/main/webapp/tests/**",
276 "src/main/webapp/node_modules/**",
277 "src/main/webapp/dist/**",
278 "src/main/webapp/doc/**",
279 ],
280 ),
281 outs = ["web_app_tests.jar"],
282 cmd = "cd web/gui2 &&" +
283 " find src/main/webapp -type f -exec touch -t 201808280000 {} \; &&" +
284 " jar Mcf ../../$@ src/main/webapp",
285)
286
287"""
288 Make a jar file of all the supporting files. Useful for breaking symblic links in the sandbox
289"""
290
291genrule(
292 name = "_angular_all",
293 srcs = [
294 ":_e2e_test_files",
295 ":_root_level_files",
296 ],
297 outs = ["angular_all.jar"],
298 cmd = " cd web/gui2 && jar Mcf ../../$@ .",
299)
300
301"""
302 Builds the java jar for the java code provided by the GUI2
303"""
304
305osgi_jar_with_tests(
306 name = "_onos-gui2-base-jar",
Sean Condon87b78502018-09-17 20:53:24 +0100307 srcs =
308 glob([
309 "src/main/java/**",
310 ]) + [
311 "//web/gui:onos-gui-java-for-gui2",
312 ],
Sean Condon3c8e5582018-08-28 23:22:43 +0100313 suppress_checkstyle = True,
Sean Condonf6af2a52018-08-19 10:43:24 +0100314 test_deps = TEST_DEPS,
315 web_context = "/onos/ui2",
316 deps = COMPILE_DEPS,
317)
318
319"""
320 Builds the tar ball for the ONOS GUI2
321"""
322
323genrule(
324 name = "onos-gui2",
325 srcs = [
326 ":_onos-gui2-ng-build",
327 ":_onos-gui2-base-jar",
328 ":_web_inf_classes_files",
Sean Condon3c8e5582018-08-28 23:22:43 +0100329 "src/main/webapp/WEB-INF/web.xml",
Sean Condonf6af2a52018-08-19 10:43:24 +0100330 ],
331 outs = ["onos-gui2.jar"],
332 cmd = " ROOT=`pwd` &&" +
333 " mkdir -p web/gui2/WEB-INF/classes &&" +
334 " cd web/gui2 &&" +
335 " BUILD_FILES=($(locations :_onos-gui2-ng-build)) &&" + # An array of filenames - sorted by time created
336 " for i in $(locations :_web_inf_classes_files); do cp $$ROOT/$$i ./WEB-INF/classes/; done &&" +
337 " (cd WEB-INF/classes && jar xf $$ROOT/$${BUILD_FILES[1]}) &&" +
338 " jar xf $$ROOT/$(location :_onos-gui2-base-jar) &&" +
339 " find . -type f -exec touch -t 201808280000 {} \; &&" +
Sean Condon3c8e5582018-08-28 23:22:43 +0100340 " jar cmf META-INF/MANIFEST.MF $$ROOT/$@ WEB-INF/web.xml WEB-INF/classes",
Sean Condonf6af2a52018-08-19 10:43:24 +0100341 output_to_bindir = 1,
342 visibility = ["//visibility:public"],
343)
344
345"""
346 Wrap the genrule for testing in a test
347"""
348
349sh_test(
350 name = "onos-gui2-ng-tests",
351 size = "small",
352 srcs = [
353 ":ng-test.sh",
354 ],
355 data = [
356 ":_onos-gui2-ng-test-genrule",
357 ],
358 deps = [
359 "@bazel_tools//tools/bash/runfiles",
360 ],
361)